<?php
namespace Catequil\Authentication\Service;

use Catequil\User\Service\UserServiceInterface;
use Mezzio\Authentication\UserInterface;

/**
 * Class UserFactory
 *
 * @package Catequil\Authentication\Service
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/catequil
 */
final class UserFactory
{
    private UserServiceInterface $users;

    /**
     * @param UserServiceInterface $users
     */
    public function __construct(UserServiceInterface $users)
    {
        $this->users = $users;
    }

    /**
     * @param string $identity
     * @return UserInterface|null
     */
    public function __invoke(string $identity): ?UserInterface
    {
        $user = $this->users->findUserByEmailAddress($identity);
        return new AuthenticatedUser($user);
    }
}